



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>扯扯淡，写个更快的memcpy</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">扯扯淡，写个更快的memcpy</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 04:49:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>写代码有时候和笃信宗教一样，一旦信仰崩溃，是最难受的事情。早年我读过云风的一篇《<a href="http://blog.codingnow.com/2005/10/vc_memcpy.html" rel="external nofollow noreferrer">VC 对 memcpy 的优化</a>》，以及《<a href="http://www.mcld.co.uk/blog/blog.php?218" rel="external nofollow noreferrer">Efficiency geek 2: copying data in C/C++, optimisation</a>》，所以我是坚信很难能写出比C运行时库更快的memcpy的。但最近有两个事情，让我对这个坚信产生了怀疑。</p>
<p>第一个个是最近在看lz4的代码，lz4可能是目前最快的内存压缩算法，部分评测他比snappy还要快点（lz4的实现后面专文剖析）。研究他的代码，发现他其中有个重要的和其他代码不同地方就是他的内存拷贝采用的是一个宏，而不是使用memcpy。其内部直接使用uint64_t转换指针进行拷贝赋值，个人估计这是他加快处理速度的一个地方。其拷贝代码大意如下，其实现不在乎字长溢出的部分。</p>
<div>
<pre class="prettyprint linenums"> //你要保证dst有足够的空间,其要求空间很可能比sz大，都是8字节补齐的。<br />
 #define ZEN_TEST_FAST_COPY(dst,src,sz)  {\<br />
     char *_cpy_dst = dst; \<br />
     const  char *_cpy_src = src; \<br />
     size_t _cpy_size = sz;\<br />
     do \<br />
 { \<br />
     ZBYTE_TO_UINT64(_cpy_dst) = ZBYTE_TO_UINT64(_cpy_src); \<br />
     _cpy_dst += sizeof(uint64_t); \<br />
     _cpy_src += sizeof(uint64_t); \<br />
 }while( _cpy_size &gt; sizeof(uint64_t) &amp;&amp; (_cpy_size -= sizeof(uint64_t))); \<br />
 }</pre>
</div>
<p>第二个是看了一篇文章<a href="http://blog.chinaunix.net/uid-20043340-id-154852.html" rel="external nofollow noreferrer">《哪个memcpy更快？》</a>。发现里面说Linux标准库的memcpy比较不堪。这个有点颠覆了。原文代码有个问题是，其在最开始对非取整的部分进行了操作。但如果memcpy的dst，src参数地址是对齐的，这样明显不利于加快速度。我改进的代码如下:</p>
<div>
<pre class="prettyprint linenums"> void *ZEN_OS::fast_memcpy(void *dst, const void *src, size_t sz)<br />
 {<br />
     void *r = dst;

     //先进行uint64_t长度的拷贝，一般而言，内存地址都是对齐的，<br />
     size_t n = sz &amp; ~(sizeof(uint64_t) - );<br />
     uint64_t *src_u64 = (uint64_t *) src;<br />
     uint64_t *dst_u64 = (uint64_t *) dst;

     while (n)<br />
     {<br />
         *dst_u64++ = *src_u64++;<br />
         n -= sizeof(uint64_t);<br />
     }

     //将没有非8字节字长取整的部分copy<br />
     n = sz &amp; (sizeof(uint64_t) - );<br />
     uint8_t *src_u8 = (uint8_t *) src;<br />
     uint8_t *dst_u8 = (uint8_t *) dst;<br />
     while (n-- )<br />
     {<br />
         (*dst_u8++ = *src_u8++);<br />
     }

     return r;<br />
 }</pre>
</div>
<p>文章代码里面还有个一个类似函数，区别在于，其在每次循环拷贝了2次uint64_t字长的数据。为了行文方便我们称之为fast_memcpy[2]把。</p>
<div>
<pre class="prettyprint linenums">     while (n)<br />
     {<br />
         *dst_u64++ = *src_u64++;<br />
         *dst_u64++ = *src_u64++;<br />
         n -= sizeof(uint64_t)*;<br />
     }</pre>
</div>
<p>为了搞明白到底如何，只有自己测试一下。测试拷贝了8，16&hellip;&hellip;64K，1M，4M字节的数据。在LINUX 64 （GCC 4.3 O3优化），Windows7 X64（Visual 2010 realse），Windwos7 win32（realse）的环境进行了测试，测试采用高精度定时器采集数据。。</p>
<p>第一组测试以字节对齐数据进行，无聊的数据就不贴了，直接上图。如果把最慢的速度比作100%，其他人作为和他的相对比率绘制图片，线条一直在下面的肯定更好一些：</p>
<p>Linux 64位下（GCC 4.3 O3优化），字节对齐情况下拷贝速度对比，如下图，</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/338451/201306/28015842-443ed7741ebb41b58eea0001a5735ff7.png" /></p>
<p>Windows7 X64,Visaul C++ 2010 Realse, 字节对齐情况下拷贝速度，如下图</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/338451/201306/28015843-91960d21830e4f3b8192db90ee201760.png" /></p>
<p>看上面的比较图片就会知道memcpy在对齐清下，memcpy在任何时候都是不错的选择。</p>
<p>但内存拷贝还有另外一种常见情况，就是字节无法对齐的情况，而lz4作为一个压缩算法，可能恰恰要经常面对无法对齐的情况，所以我针对这种情况也做了一下测试。</p>
<p>Linux 64位下（GCC 4.3 O3优化），字节非对齐情况下拷贝速度，如下图，</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/338451/201306/28015845-c705db9cead948e3ab4596a82a33eff5.png" /></p>
<p>Windows7 X64,Visaul C++ 2010 Realse, 字节非对齐情况下拷贝速度，如下图，宏的拷贝</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog/338451/201306/28015849-2d932f1fcff3426bbd07821dfbb33271.png" /></p>
<p>在字节不对齐的情况下，并且拷贝的内存长度小于256字节，用8字节的赋值方式速度会稍微优于memcpy，这可能也是lz4采用这个方法的原因。如果拷贝的尺寸更大的不对齐时，memcpy还是更好的选择。而考虑到lz4大部分情况面对的拷贝字节，应该小于256字节。所以他采用宏拷贝的方式理论上是可以获得一些优势。</p>
<p><strong>结论：</strong></p>
<p><strong>在字节对齐的情况下，memcpy在任何时候几乎都是最优的选择</strong>。</p>
<p>确实有些方法在特定条件下比memcpy快一点。但<strong>如果你不知道如何选择，默认还是选择memcpy为好。同理也适应memset函数</strong>。</p>
<p>Windows 平台上，如果数据长度达到1M或者4M，Windows的下的表现要好于Linxu平台，特别是在64位的平台上。（当然Linux测试环境是虚拟机，是否有一定影响？），可能的原因为止，和frostburn掰扯估计Windows下指令优化也许有过GCC之处。</p>
<p>写出比运行时库memcpy更快函数，这本身就是一个比较扯淡的事情，你的对手有编译器优化，代码运行优化，指令优化等多种手段。《哪个memcpy更快？》一文应该是有缪误的。当然他可能有他的背景(没有开优化？)，作者可能并没有说清。</p>
<p>参考文档以及背景阅读：</p>
<p>《<a href="http://blog.codingnow.com/2005/10/vc_memcpy.html" rel="external nofollow noreferrer">VC 对 memcpy 的优化</a>》 云风解释的VC对于各种拷贝长度，编译器做的优化。</p>
<p>《<a href="http://www.mcld.co.uk/blog/blog.php?218" rel="external nofollow noreferrer">Efficiency geek 2: copying data in C/C++, optimisation</a>》作者对一些Geek的方法做了评估，当然第一篇memset部分写的更为详细一些。有些Geek作法大家可以看看。《<a href="http://blog.163.com/lzh_327/blog/static/7219480201110184108805/" rel="external nofollow noreferrer">各种版本的memcpy（底层优化）</a>》一问解释一些数据拷贝的优化方法。《<a href="http://www.embedded.com/design/embedded/4024961/Optimizing-Memcpy-improves-speed" rel="external nofollow noreferrer">Optimizing Memcpy improves speed</a>》这个里面提到的memcpy也不是我们所说的C运行时库的memcpy，但此文也解释了一些的提速数据拷贝方法。</p>
<p>《<a href="http://blog.chinaunix.net/uid-20043340-id-154852.html" rel="external nofollow noreferrer">哪个memcpy更快？</a>》误导我的文章，我认为他所述的东东应该有个特殊场景。或者他说的C库的memcpy和我理解就不是一个东东？</p>
<p>《<a href="http://nadeausoftware.com/articles/2012/05/c_c_tip_how_copy_memory_quickly" rel="external nofollow noreferrer">C/C++ tip: How to copy memory quickly</a>》文章也说明了这个问题，他的结论和我们一样。</p>
<p>【本文作者是<a href="http://t.qq.com/insail" rel="external nofollow noreferrer">雁渡寒潭</a>，本着自由的精神，你可以在无盈利的情况完整转载此文 档，转载时请附上BLOG链接:http://www.cnblogs.com/fullsail/，否则每字一元，每图一百不讲价。对Baidu文库和360doc加价一倍】</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qx2ne08.html">Sqlserver 中系统表sysobjects、syscolumns以及函数object＿id</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o43k1q.html">Writing to a MySQL database from SSIS</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vjw0j8.html">一步步学Mybatis-搭建最简单的开发环境-开篇（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnxok08.html">Android开发UI之布局文件LinearLayout</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm7mel9.html">弹出层iframe链接设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w7kdlq.html">opencv 中cvZero（）的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zogdrnq.html">HNCU1741：算法3-2：行编辑程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gee4g48.html">Ubuntu 13&period;04&sol;12&period;10安装Oracle 11gR2图文教程&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90my2p38.html">python中的可变与不可变对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey6edz9.html">Laravel框架中的make方法详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1ko1gq.html">gVim编辑器 操作篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvd36k8.html">随机总数字里面选取随机数字进行随机排序案例&lpar;JAVA实现&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw7g6k8.html">ceph存储集群性能测试工具步骤（初稿）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2jx5j9.html">【比赛打分展示双屏管理系统-专业版】Other&period;ini 配置文件解读以及排行榜界面及专家评语提交展示等具体配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r16yj9.html">如何取得select结果数据集的前10条记录。postgresql</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlveek9.html">the most beautiful media player on the linux platform&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1l31k9.html">flowable 的ProcessEngine配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvek7zx9.html">极大提高Web开发效率的8个工具和建议（含教程）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em3pkj9.html">PAT乙级1002</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1xwy09.html">linux下安装shellinabox实现web登录服务器</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8oklkel9.html">C&plus;&plus; 嵌套类使用（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y3y0eq.html">眼见为实&lpar;1&rpar;：C&plus;&plus;基本概念在编译器中的实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vkmkm8.html">HDU4545&plus;LCS</a>
			</li>
						<li><a href="https://www.batexi.com/a/qderprx9.html">&lbrack;Ruby on Rails系列&rsqb;5、专题：Talk About SaSS</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m0o0xq.html">Mac OS X 启用 Web 服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmrjrl9.html">转--利用函数模板技术，写一个简单高效的 JSON 查询器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wyx1oq.html">Hadoop分布式文件系统（HDFS）详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1rme39.html">No bean named &amp;&num;39&semi;transactionManager&amp;&num;39&semi; is defined</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj2x2k9.html">【HDOJ】4336 Card Collector</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x7jvm8.html">Monitor vs WaitHandle</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
